using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Couleurs
{
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }
  int WCell = 30, HCell = 25;
  int LI = 10, COL = 15;
  private System.Windows.Forms.ToolTip ttCouleur;
  string[] tabCoul = 
    {"AliceBlue", "AntiqueWhite", "Aqua", "Aquamarine", "Azure",
     "Beige", "Bisque", "Black", "BlanchedAlmond", "Blue", "BlueViolet", "Brown", "BurlyWood",
     "CadetBlue", "Chartreuse", "Chocolate", "Coral", "Cornflower", "Cornsilk", "Crimson", "Cyan",
     "DarkBlue", "DarkCyan", "DarkGoldenrod", "DarkGray", "DarkGray", "DarkGreen", "DarkKhaki",
        "DarkMagenta", "DarkOliveGreen", "DarkOrange", "DarkOrchid", "DarkRed", "DarkSalmon", 
        "DarkSeaGreen", "DarkSlateBlue", "DarkSlateGray", "DarkTurquoise", "DarkViolet", 
        "DeepPink", "DeepSkyBlue", "DimGray", "DodgerBlue",
     "FireBrick", "FloralWhite", "ForestGreen", "Fuschia",
     "Gainsboro", "GhostWhite", "Gold", "Goldenrod", "Gray", "Green", "GreenYellow",
     "Honeydew", "HotPink", 
     "IndianRed", "Indigo", "Ivory",
     "Khaki",
     "Lavender", "LavenderBlush", "LawnGreen", "LemonChiffon", "LightBlue", "LightCoral", "LightCyan", 
        "LightGoldenrodYellow", "LightGray", "LightGreen", "LightPink", "LightSalmon", "LightSeaGreen",
        "LightSlateGray", "LightSteelBlue", "LightYellow", "Lime", "LimeGreen", "Linen",
     "Magenta", "Maroon", "MediumAquaMarine", "MediumBlue", "MediumOrchid", "MediumPurple",
        "MediumSeaGreen", "MediumSlateBlue", "MediumSpringGreen", "MediumTurquoise", 
        "MediumVioletRed", "MidnightBlue", "MintCream", "MistyRose", "Moccasin",
     "NavajoWhite", "Navy",
     "OldLace", "Olive", "OliveDrab", "Orange", "OrangeRed", "Orchid", 
     "PaleGoldenrod", "PaleGreen", "PaleTurquoise", "PaleVioletRed", "PapayaWhip", "PeachStuff", 
        "Peru", "Pink", "Plum", "PowderBlue", "Purple", 
     "Red", "RosyBrown", "RoyalBlue",
     "SaddleBrown", "Salmon", "SandyBrown", "SeaGreen", "SeaShell", "Sienna", "Silver", "SkyBlue",
        "SlateBlue", "Snow", "SpringGreen", "SteelBlue", 
     "Tan", "Teal", "Thistle", "Tomato", "Turquoise",
     "Violet", 
     "Wheat", "White", "WhiteSmoke",
     "Yellow", "YellowGreen"
    };
  private void Form1_Load(object sender, EventArgs e)
  {
   this.ClientSize = new Size(WCell * COL, HCell * LI);
  }

  private void Form1_Paint(object sender, PaintEventArgs e)
  {
   Rectangle[] tabRect = new Rectangle[LI * COL];
   for (int li = 0; li < LI; li++)
    for (int col = 0; col < COL; col++)
    {
     Rectangle r = new Rectangle(col * WCell, li * HCell, WCell, HCell);
     if (li * COL + col < tabCoul.Length)
     {
      Color c = Color.FromName(tabCoul[li * COL + col]);
      e.Graphics.FillRectangle(new SolidBrush(c), r);
     }
    }
  }

  private void Form1_MouseMove(object sender, MouseEventArgs e)
  {
   int col = e.X / WCell, li = e.Y / HCell;
   string s = "";
   if (li * COL + col < tabCoul.Length) s = tabCoul[li * COL + col];
   ttCouleur.SetToolTip(this, s);
  }
 }
}