﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Drawing.Drawing2D;

namespace Tracés
{
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }

  Color CouleurFond = Color.DarkCyan, CouleurTrait = Color.Yellow;
  private void bSelCoulFond_Click(object sender, System.EventArgs e)
  {
   DialogResult res = diaSelCouleur.ShowDialog();
   if (res == DialogResult.OK)
   {
    CouleurFond = diaSelCouleur.Color;
    Invalidate(false);
   }
  }

  private void bSelCoulTrait_Click(object sender, System.EventArgs e)
  {
   DialogResult res = diaSelCouleur.ShowDialog();
   if (res == DialogResult.OK)
   {
    CouleurTrait = diaSelCouleur.Color;
    Invalidate(false);
   }
  }
  GraphicsPath gp;
  private void bBolygoneTracer_Click(object sender, System.EventArgs e)
  {
   // lire les zones d'édition
   int N;
   int NbMillisec;
   try { N = Int32.Parse(zeBolygoneOrdre.Text); }
   catch (Exception) { MessageBox.Show("N doit être un entier"); return; }
   try { NbMillisec = Int32.Parse(zeDurée.Text); }
   catch (Exception) { MessageBox.Show("Le nombre de millisecondes doit être un entier"); return; }

   // réinitialiser le GraphicsPath
   gp = new GraphicsPath();
   // Fond de couleur
   Rectangle rc = new Rectangle(new Point(300, 0), ClientSize);
   Graphics g = CreateGraphics();
   g.FillRectangle(new SolidBrush(CouleurFond), rc);

   int xCentre = 550, yCentre = 250, rayon = 150;
   int X1, Y1, X2, Y2;
   double angleD, angleR;
   int P = 1;

   for (angleD = 0; angleD < 360; angleD += P)
   {
    angleR = angleD * 3.1416 / 180;
    X1 = (int)(xCentre + rayon * Math.Cos(angleR));
    Y1 = (int)(yCentre + rayon * Math.Sin(angleR));

    X2 = (int)(xCentre + rayon * Math.Cos(angleR * N));
    Y2 = (int)(yCentre + rayon * Math.Sin(angleR * N));
    g.DrawLine(new Pen(CouleurTrait), X1, Y1, X2, Y2);
    gp.AddLine(X1, Y1, X2, Y2);

    Application.DoEvents();
    Thread.Sleep(NbMillisec);
   }
  }

  private void bSpiraleTracer_Click(object sender, System.EventArgs e)
  {
   int N, D, K, NbMillisec;
   try { N = Int32.Parse(zeSpiraleN.Text); }
   catch (Exception) { MessageBox.Show("N doit être un entier"); return; }
   try { D = Int32.Parse(zeSpiraleD.Text); }
   catch (Exception) { MessageBox.Show("D doit être un entier"); return; }
   try { K = Int32.Parse(zeSpiraleK.Text); }
   catch (Exception) { MessageBox.Show("K doit être un entier"); return; }
   try { NbMillisec = Int32.Parse(zeDurée.Text); }
   catch (Exception) { MessageBox.Show("Le nombre de millisecondes doit être un entier"); return; }

   // réinitialiser le GraphocsPath
   gp = new GraphicsPath();

   // Fond de couleur
   Rectangle rc = new Rectangle(new Point(300, 0), ClientSize);
   Graphics g = CreateGraphics();
   g.FillRectangle(new SolidBrush(CouleurFond), rc);

   int xCentre = 550, yCentre = 250, rayon = 150;
   int X1, Y1, X2, Y2;

   double[] tabX = new double[N + 1], tabY = new double[N + 1];

   // Remplissage de la table des coordonnées
   int C = 0;
   for (double A = 0; A < 360; A += 360.0 / N)
   {
    double AR = A * 3.1416 / 180;
    tabX[C] = (int)(xCentre + rayon * Math.Cos(AR));
    tabY[C] = (int)(yCentre + rayon * Math.Sin(AR));
    C++;
   }
   tabX[N] = tabX[0]; tabY[N] = tabY[0];

   for (int i = 0; i < K; i++)    // tracer les K polygones emboîtés
   {
    X1 = (int)tabX[0]; Y1 = (int)tabY[0];

    for (int j = 1; j <= N; j++)   // tracé d'un polygone
    {
     X2 = (int)tabX[j]; Y2 = (int)tabY[j];
     g.DrawLine(new Pen(CouleurTrait), X1, Y1, X2, Y2);
     gp.AddLine(X1, Y1, X2, Y2);
     X1 = X2; Y1 = Y2;
     Application.DoEvents();
     Thread.Sleep(NbMillisec);
    }

    for (int j = 0; j < N; j++)
    {
     tabX[j] = tabX[j] + (tabX[j + 1] - tabX[j]) / D;
     tabY[j] = tabY[j] + (tabY[j + 1] - tabY[j]) / D;
    }
    tabX[N] = tabX[0]; tabY[N] = tabY[0];
   }
  }

  private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
  {
   if (gp != null)
   {
    Rectangle rc = new Rectangle(new Point(300, 0), ClientSize);
    e.Graphics.FillRectangle(new SolidBrush(CouleurFond), rc);
    e.Graphics.DrawPath(new Pen(CouleurTrait), gp);
   }
  }
  
 }
}