using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace Tris
{
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }

  int N = 10;    // Nombre de nombres  trier
  int[] tab;
  Color[] tabCouleurs;

  private void bData_Click(object sender, System.EventArgs e)
  {
   Random rndm = new Random();
   for (int i = 0; i < 10; i++) tab[i] = 1 + rndm.Next() % 10;
   Invalidate();
  }

  private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
  {
   for (int i = 0; i < N; i++)
   {
    Brush br = new SolidBrush(tabCouleurs[i]);
    int X = Width / 11 * i + 40, W = Width / 15,
        H = tab[i] * Height / 15;
    int Y = 100 + (Height * 10 / 15 - H);
    e.Graphics.FillRectangle(br, X, Y, W, H);
   }
  }
  void ech(int a, int b)
  {
   int temp = tab[a]; tab[a] = tab[b]; tab[b] = temp;
  }

  bool CheckEscape()
  {
   if (bEscaped)
   {
    stBar.Text = "Tri prmaturment termin";
    bEscaped = false;
    return true;
   }
   else return false;
  }

  void AffichageSuivant()
  {
   if (bModeStep)
   {
    stBar.Text += " .... pause ! Appuyer sur une touche pour continuer";
    bContinue = false;
    while (bContinue == false)
    {
     Application.DoEvents();
     Thread.Sleep(500);
    }
    bContinue = false;
   }
   else
   {
    Application.DoEvents();
    Thread.Sleep(1000);
   }
  }

  string sMode;
  private void bTriSel_Click(object sender, System.EventArgs e)
  {
   int N = tab.Length;
   for (int i = 0; i < N - 1; i++)
   {
    if (CheckEscape()) return;
 
    // rechercher le plus petit parmi les suivants du i-ime
    int mini = i + 1; 
    for (int j = i + 2; j < N; j++)
     if (tab[mini] > tab[j]) mini = j;
    // procder ventuellement  l'change
    if (tab[i] > tab[mini])
    {
     stBar.Text = "On va procder  un change : " + tab[i] + " ( l'indice " + i + ")  et "
                       + tab[mini] + " ( l'indice " + mini + ") vont tre changs";
     // signaler en rouge les nombres qui vont tre changs
     for (int k = 0; k < N; k++)
      tabCouleurs[k] = (k == i || k == mini) ? Color.Red : Color.Blue;
     Invalidate();
     AffichageSuivant();
     if (CheckEscape()) return;
   
     // changer les nombres et signaler en vert les nombres changs
     ech(i, mini);
     tabCouleurs[i] = Color.Green; tabCouleurs[mini] = Color.Green;
     stStrip.Items[0].Text = tab[i] + " ( l'indice " + i + ") et " +
                       tab[mini] + " ( l'indice " + mini + ") ont t changs";
     Invalidate();
     AffichageSuivant();

     if (CheckEscape()) return;

     // remettre tout en bleu     
     for (int k=0; k<N; k++) 
      tabCouleurs[i] = Color.Green; tabCouleurs[mini] = Color.Green;
     Invalidate();
     AffichageSuivant();

     if (CheckEscape()) return;
    }
   }
   stBar.Text = bEscaped==false ? "Tri termin" : "Tri prmaturment termin";
   for (int k = 0; k < N; k++)
    tabCouleurs[k] = Color.Blue;
   Invalidate();
   bEscaped = false;
  }

  private void bTriBulle_Click(object sender, System.EventArgs e)
  {
   bool Echange;
   int NRep = N;
   do
   {
    Echange = false;
    for (int i = 0; i < NRep - 1; i++)
     if (tab[i] > tab[i + 1])
     {
      if (CheckEscape()) return;
      stBar.Text = "On va changer " + tab[i] + " ( l'indice " + i + ") et"
                        + tab[i + 1] + " ( l'indice " + (i + 1) + ")";
      // signaler en rouge les nombres qui vont tre changs
      for (int k = 0; k < N; k++)
       tabCouleurs[k] = (k == i || k == i + 1) ? Color.Red : Color.Blue;
      Invalidate();
      AffichageSuivant();
      if (CheckEscape()) return;
      // Echanger 
      ech(i, i + 1); Echange = true;
      tabCouleurs[i] = Color.Green; tabCouleurs[i + 1] = Color.Green;
      stBar.Text = tab[i] + " ( l'indice " + i + ") et " +
                        tab[i + 1] + " ( l'indice " + (i + 1) + ") ont t changs";
      Invalidate();
      AffichageSuivant();
      if (CheckEscape()) return;
      // remettre tout en bleu     
      tabCouleurs[i] = Color.Blue; tabCouleurs[i + 1] = Color.Blue;
      Invalidate();
      AffichageSuivant();
      if (CheckEscape()) return;
     }
    stBar.Text = "Termin";
    for (int k = 0; k < N; k++)
     tabCouleurs[k] = Color.Blue;
    Invalidate();
    NRep--;
   } while (Echange == true);
  }

  private void bTriShell_Click(object sender, System.EventArgs e)
  {
   int N = tab.Length, pas = N / 2;
   bool Echange;
   while (pas > 0)
   {
    Echange = false;
    for (int i = 0; i < N - pas; i++)
     if (tab[i] > tab[i + pas])
     {
      if (CheckEscape()) return;
      stBar.Text = "On va changer " + tab[i] + " ( l'indice " + i + ") et"
                        + tab[i + pas] + " ( l'indice " + (i + pas) + ")";
      // signaler en rouge les nombres qui vont tre changs
      for (int k = 0; k < N; k++)
       tabCouleurs[k] = (k == i || k == i + pas) ? Color.Red : Color.Blue;
      Invalidate();
      AffichageSuivant();
      if (CheckEscape()) return;
      // Echanger
      ech(i, i + pas);
      tabCouleurs[i] = Color.Green; tabCouleurs[i + pas] = Color.Green;
      stStrip.Items[0].Text = tab[i] + " ( l'indice " + i + ") et " +
                        tab[i + pas] + " ( l'indice " + (i + pas) + ") ont t changs";
      Invalidate();
      AffichageSuivant();
      if (CheckEscape()) return;
      // remettre tout en bleu     
      tabCouleurs[i] = Color.Blue; tabCouleurs[i + pas] = Color.Blue;
      Invalidate();
      AffichageSuivant();
      if (CheckEscape()) return;
      Echange = true;
     }
    if (Echange == false) pas /= 2;
   }
   stStrip.Items[0].Text = "Termin";
   for (int k = 0; k < N; k++) tabCouleurs[k] = Color.Blue;
   Invalidate();
  }

  private void Form1_Load(object sender, EventArgs e)
  {
   tab = new int[10];
   Random rndm = new Random();
   for (int i = 0; i < 10; i++) tab[i] = 1 + rndm.Next() % 10;
   tabCouleurs = new Color[10];
   for (int i = 0; i < tabCouleurs.Length; i++) tabCouleurs[i] = Color.Blue;
   stBar.Text = "F1 pour Mode Step (dans ce cas, n'importe quelle touche pour passer  l'tape suivante) et ESC pour terminer prmaturment le tri";
  }
  bool bEscaped = false, bContinue = false, bModeStep;
  private void Form1_KeyPress(object sender, KeyPressEventArgs e)
  {
   if (e.KeyChar == 27) { bEscaped = true; bModeStep = false; }
  }

  private void Form1_KeyUp(object sender, KeyEventArgs e)
  {
   if (e.KeyCode == Keys.F1)
   {
    bModeStep = !bModeStep;
    sMode = bModeStep ? "Mode step : " : "Mode automatique ";
    stBar.Text = sMode;
   }
   else if (bModeStep) bContinue = true;
  }
 }
}